<?php

//* Include Spoonflower brand bar markup in header
add_action( 'genesis_header', 'sb_brandbar_markup', 4 );
function sb_brandbar_markup() {
    ?>
    <div class="brand-bar">
        <div class="wrap">
            <span class="alignleft spoon-link"><a href="http://www.spoonflower.com">Go to Spoonflower.com</a></span>
            <span class="alignright spoon-tag"><i>Design, Sell, & Shop Fabric, Wallpaper, & Gift Wrap</i></span>
        </div>
    </div>
    <?php   
}

//* Spoonflower footer markup
//* Customize footer
remove_action( 'genesis_footer', 'genesis_do_footer' );
add_action( 'genesis_footer', 'sb_custom_footer' );
function sb_custom_footer() {
    ?>
<div id="ft">
      <div class="footer">
          <div class="entire_ft">
            <div class="create_ft">
              <div class="entire_ft">
              <ul class="nav aboutus_chrome">
                <li class="footer_li" id="create_header">
                  <a class="footer_header_link"><div id="create_header_words">Create</div></a>
                </li>
                <ul id="create_ft" class="secondary terms_chrome">
                  <li class="footer_li"><a href="http://www.spoonflower.com/designs/new?create=fabric"><div>fabric</div></a></li>
                  <li class="footer_li"><a href="http://www.spoonflower.com/designs/new?create=wallpaper"><div>wallpaper</div></a></li>
                  <li class="footer_li"><a href="http://www.spoonflower.com/designs/new?create=gift_wrap"><div>gift wrap</div></a></li>
                  <li class="footer_li"><a href="https://support.spoonflower.com/hc/en-us/sections/200793490-Creating"><div>faqs</div></a></li>
                </ul>
              </ul>
              </div>
            </div>

            <div class="shop_ft">
              <div class="entire_ft">
                <ul class="nav aboutus_chrome">
                  <li class="footer_li" id="shop_header">
                    <a class="footer_header_link"><div id="shop_header_words" class="studio_header">Shop</div></a>
                  </li>
                  <ul id="shop_ft" class="secondary terms_chrome">
                    <li class="footer_li"><a href="http://www.spoonflower.com/shop?shop=fabric"><div>Fabric</div></a></li>
                    <li class="footer_li"><a href="http://www.spoonflower.com/shop?shop=wallpaper"><div>wallpaper</div></a></li>
                    <li class="footer_li"><a href="http://www.spoonflower.com/shop?shop=gift_wrap"><div>gift wrap</div></a></li>
                    <li class="footer_li"><a href="http://www.spoonflower.com/design_tools"><div>design tools</div></a></li>
                    <li class="footer_li"><a href="http://www.spoonflower.com/gift_ideas"><div>gift ideas</div></a></li>
                    <li class="footer_li"><a href="https://support.spoonflower.com/hc/en-us/sections/200793490-Creating"><div>faqs</div></a></li>
                  </ul>
                </ul>
              </div>
            </div>

            <div class="shop_ft">
              <div class="entire_ft">
                <ul class="nav aboutus_chrome">
                  <li class="footer_li" id="connect_header">
                    <a class="footer_header_link"><div id="connect_header_words">Connect</div></a>
                  </li>
                  <ul id="connect_ft" class="secondary terms_chrome">
                    <li class="footer_li"><a href="http://www.spoonflower.com/connect"><div>community</div></a></li>
                      <li class="footer_li"><a href="http://www.spoonflower.com/contests/bucketfeet-oceans-finals"><div>Design Challenge</div></a></li>
                    <li class="footer_li"><a href="http://www.spoonflower.com/contests"><div>Past Challenges</div></a></li>
                    <li class="footer_li"><a href="http://blog.spoonflower.com/"><div>Blog</div></a></li>
                    <li class="footer_li"><a href="http://www.spoonflower.com/events"><div>events</div></a></li>
                    <li class="footer_li"><a href="http://www.spoonflower.com/feedback/new"><div>contact us</div></a></li>
                  </ul>
                </ul>
              </div>
            </div>


        <div class="more_div">
          <ul class="nav aboutus_chrome more_chrome">
            <li class="footer_li desktop_hide" id="more_header">
              <a class="footer_header_link"><div id="more_header_words">More</div></a>
            </li>
            <ul id="more_ft" class="secondary terms_chrome more_chrome">
              <li><a href="http://www.spoonflower.com/about">About us</a></li>
              <li><a href="http://www.spoonflower.com/press">Press</a></li>
              <li><a href="http://blog.spoonflower.com/jobs-at-spoonflower.html" target="_blank">Jobs</a></li>
              <li><a href="http://sproutpatterns.com">Sprout Patterns</a></li>
              <li><a href="http://www.spoonflower.com/design_grant">Emerging Designer Grant</a></li>
              <li><a href="http://www.spoonflower.com/privacy">Privacy</a></li>
              <li><a href="http://www.spoonflower.com/terms">Terms of Service</a></li>
              <li><a href="http://www.spoonflower.com/pro_terms">Pro Terms of Service</a></li>
              <li><a href="http://www.spoonflower.com/seller_agreement">Seller Agreement</a></li>
              <li class="mobile_hide">© 2008-2016 Spoonflower Inc</li>
              <li>        <div class="mobile_social_media desktop_hide">
          <a href="http://www.facebook.com/spoonflower" style="margin-left:0px" target="_blank"><img alt="Facebook_mobile" src="http://www.spoonflower.com/assets/social_media_icons/Facebook_Mobile.png"></a>
          <a href="http://www.flickr.com/photos/spoonflower/" style="margin-left:0px" target="_blank"><img alt="Flickr_mobile" src="http://www.spoonflower.com/assets/social_media_icons/Flickr_Mobile.png"></a>
          <a href="http://pinterest.com/spoonflower/" style="margin-left:0px" target="_blank"><img alt="Pinterest_mobile" src="http://www.spoonflower.com/assets/social_media_icons/Pinterest_Mobile.png"></a>
          <a href="http://twitter.com/spoonflower" style="margin-left:0px" target="_blank"><img alt="Twittermobile" src="http://www.spoonflower.com/assets/social_media_icons/TwitterMobile.png"></a>
          <a href="http://instagram.com/spoonflower" style="margin-left:0px" target="_blank"><img alt="Instagram_mobile" src="http://www.spoonflower.com/assets/social_media_icons/Instagram_Mobile.png"></a>
        </div></li>

            </ul>
          </ul>
        </div>

</div>

    <?php
}



//* Include a search bar in the header
add_action( 'genesis_header', 'sb_add_search_form' );
function sb_add_search_form(){
    get_search_form();
}



//* Add related posts to individual post views

add_action( 'genesis_before_comments', 'sb_related_posts', 12 );
/**
 * Outputs related posts with thumbnail
 *
 * @author Nick the Geek
 * @url http://designsbynickthegeek.com/tutorials/related-posts-genesis
 * @global object $post
 */
function sb_related_posts() {

    global $do_not_duplicate;

    if ( ! is_singular ( 'post' ) ) {
        return;
    }

    $count = 0;

    $related = '';

    $do_not_duplicate = array();

    $tags = wp_get_post_tags( get_the_ID() );

    $cats = wp_get_post_categories( get_the_ID() );

    // If we have some tags, run the tag query.
    if ( $tags ) {
        $query    = sb_related_tag_query( $tags, $count );
        $related .= $query['related'];
        $count    = $query['count'];
    }

    // If we have some categories and less than 5 posts, run the cat query.
    if ( $cats && $count <= 3 ) {
        $query    = sb_related_cat_query( $cats, $count );
        $related .= $query['related'];
        $count    = $query['count'];
    }

    // End here if we don't have any related posts.
    if ( ! $related ) {
        return;
    }

    // Display the related posts section.
    echo '<div class="related">';
        echo '<h3 class="related-title">Related Posts</h3>';
        echo '<div class="related-posts-list" data-columns>' . $related . '</div>';
    echo '</div>';

}

function sb_related_tag_query( $tags, $count ) {

    global $do_not_duplicate;

    if ( ! $tags ) {
        return;
    }

    $postIDs = array( get_the_ID() );

    foreach ( $tags as $tag ) {
        $tagID[] = $tag->term_id;
    }

    $tax_query = array(
        array(
            'taxonomy'  => 'post_format',
            'field'     => 'slug',
            'terms'     => array(
                'post-format-link',
                'post-format-status',
                'post-format-aside',
                'post-format-quote'
                ),
            'operator' => 'NOT IN'
        )
    );
    $args = array(
        'tag__in'               => $tagID,
        'post__not_in'          => $postIDs,
        'showposts'             => 4,
        'ignore_sticky_posts'   => 1,
        'tax_query'             => $tax_query,
    );

    $related  = '';

    $tag_query = new WP_Query( $args );

    if ( $tag_query->have_posts() ) {
        while ( $tag_query->have_posts() ) {
            $tag_query->the_post();

            $do_not_duplicate[] = get_the_ID();

            $count++;

            // $title = genesis_truncate_phrase( get_the_title(), 35 );
            $title = get_the_title();

            $related .= '<div class="related-post">';
            $related .= '<a class="related-image" href="' . get_permalink() . '" rel="bookmark" title="Permanent Link to ' . $title . '">' . genesis_get_image( array( 'size' => 'related' ) ) . '</a>';
            $related .= '<div class="related-post-title"><a href="' . get_permalink() . '" rel="bookmark" title="Permanent Link to ' . $title . '">' . $title . '</a></div>';
            $related .= '</div>';
        }
    }

    wp_reset_postdata();

    $output = array(
        'related' => $related,
        'count'   => $count
    );

    return $output;
}

function sb_related_cat_query( $cats, $count ) {

    global $do_not_duplicate;

    if ( ! $cats ) {
        return;
    }

    $postIDs = array_merge( array( get_the_ID() ), $do_not_duplicate );

    $catIDs = array();

    foreach ( $cats as $cat ) {
        if ( 3 == $cat ) {
            continue;
        }
        $catIDs[] = $cat;
    }

    $showposts = 4 - $count;

    $tax_query = array(
        array(
            'taxonomy'  => 'post_format',
            'field'     => 'slug',
            'terms'     => array(
                'post-format-link',
                'post-format-status',
                'post-format-aside',
                'post-format-quote'
                ),
            'operator' => 'NOT IN'
        )
    );
    $args = array(
        'category__in'          => $catIDs,
        'post__not_in'          => $postIDs,
        'showposts'             => $showposts,
        'ignore_sticky_posts'   => 1,
        'orderby'               => 'rand',
        'tax_query'             => $tax_query,
    );

    $related  = '';

    $cat_query = new WP_Query( $args );

    if ( $cat_query->have_posts() ) {
        while ( $cat_query->have_posts() ) {
            $cat_query->the_post();

            $count++;

            // $title = genesis_truncate_phrase( get_the_title(), 35 );
            $title = get_the_title();

            $related .= '<div class="related-post">';
            $related .= '<a class="related-image" href="' . get_permalink() . '" rel="bookmark" title="Permanent Link to ' . $title . '">' . genesis_get_image( array( 'size' => 'related' ) ) . '</a>';
            $related .= '<div class="related-post-title"><a href="' . get_permalink() . '" rel="bookmark" title="Permanent Link to ' . $title . '">' . $title . '</a></div>';
            $related .= '</div>';
        }
    }

    wp_reset_postdata();

    $output = array(
        'related' => $related,
        'count'   => $count
    );

    return $output;

}